#!/bin/sh
#


usage()
{
echo "Usage: $0 DataChannel-install-dir
DataChannel-install-dir is the directory where the DataChannel is installed
"
        return 0
}

File_List()
{
# List of ifixes
#
cd patch
PFILE_LIST=`ls`
cd ..
}

unpack_files()
{
        tar -xf $patch
}

cleanup_files()
{
        rm -rf "$FP_DIR/patch"  && return 0
}


startup_file()
{
#
# Startup file to load the patch
#
SFILE=$DC_HOME/state/`$DC_HOME/bin/version|tail -1|sed 's/[   -][     ]*/ /g'|cut -d' ' -f3`.startup
[ -f $DC_HOME/state/$SFILE.backup ] && rm $DC_HOME/state/$SFILE.backup
cp $DC_HOME/state/$SFILE $DC_HOME/state/$SFILE.backup
USER=`id | awk -F"(" '{print $2}' | awk -F")" '{print $1}'`
GROUP=`ls -g $DC_HOME/bin/version | awk '{print $3}'`
}


action()
{
cd patch
for PFILE in ${PFILE_LIST}
do
   if [ -f "$DC_HOME/state/$PFILE" ]
   then
      #
      # Skip the installation...
      #
      echo "Patch file $PFILE already exists in $DC_HOME/state"
   else
      echo "Installing patch file $PFILE in $DC_HOME/state"
      cp ./$PFILE $DC_HOME/state/$PFILE
      chown $USER:$GROUP $DC_HOME/state/$PFILE

      echo "Updating $SFILE"
      echo "'../state/$PFILE' asFilename fileIn." >> $SFILE
   fi
done
cd ..
}


P_DIR=`pwd`
patch=patch.tar
DC_HOME="$1"
[ -z "$DC_HOME" ] && usage && exit 1

echo "Unpacking..." && unpack_files || exit 1

echo "Create file list" && File_List || exit 1

echo "Cleaning up..." && cleanup_files || exit 1

echo "Find current startup file...."  && startup_file || exit 1

echo "Installing patches..." && action 

echo "Cleanup..." && cleanup_files

echo "Success."

exit 0

