<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on June 23, 2008 at 6:35:09 pm</time-stamp>
<!-- Changes from: PV-DM-Support(Kila.66,bbuxton)  to: PV-DM-Support(Kila.68,apikovsky) -->


<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptCalendarSegmentWeekdayInterval:">acceptCalendarSegmentWeekdayInterval: aSegment

	| base dayStart offset |
	base := self timestamp weekStartSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	self addSegmentBoundaryFrom: base to: self timestamp weekStopSeconds.
	aSegment weekdayIndices do: [:ix | |dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		self 
			addIntervalFrom: (dayStart + aSegment fromTimeSeconds)
			to: (dayStart + aSegment toTimeSeconds)
	]</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentWeekendInterval:">acceptCalendarSegmentWeekendInterval: aSegment
	| base dayStart offset |
	base := self timestamp weekStartSeconds.
	self addSegmentBoundaryFrom: base to: self timestamp weekStopSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	aSegment weekendIndices do: [:ix | |dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		self 
			addIntervalFrom: (dayStart + aSegment fromTimeSeconds)
			to: (dayStart + aSegment toTimeSeconds)
	]</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentEnumeratedWeekInterval:">acceptCalendarSegmentEnumeratedWeekInterval: aSegment 
	
	| base offset |
	base := self timestamp weekStartSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	self 
		addSegmentBoundaryFrom: base
		to: self timestamp weekStopSeconds.
	aSegment weekEnumerationIndices do: [:ix | |dayStart dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		self 
			addIntervalFrom: dayStart + aSegment fromTimeSeconds
			to: dayStart + aSegment toTimeSeconds]</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>api</category>

<body package="PV-DM-Support" selector="intervalForTimestamp:">intervalForTimestamp: aSeconds 
	" It is possible that end of an implicitly built period and the start of explicitly ('in') period overlap. This should really be fixed
	in the build code to prevent this prom happening. In the meantime first search for explicitly built interval, then for an 
	implicit one "
	| result |
	((result := self lastInterval) notNil and: [result includes: aSeconds]) 
		ifTrue: [^result].
	^(self extendHorizonToInclude: aSeconds) ifNotNil: 
		[result := 
			self intervals 
				detect: [:each | (each includes: aSeconds) and: [each inSegment]]
				ifNone: 
					[self intervals 
						detect: [:each | each includes: aSeconds]
						ifNone: [^nil]].
		self lastInterval: result.
		result]</body>
</methods>



</st-source>
