<?xml version="1.0"?>

<st-source>
<!-- Changes in change set ra503307-duplicatesForSameTime -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on June 23, 2008 at 1:06:50 pm</time-stamp>


<methods>
<class-id>PROVISO.FormulaWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		aFormulaOperator lastTuple: aTuple.
		ts onAddTuple: aTuple.</body>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator lastTuple 
		ifNil: 
			[aFormulaOperator timeSeries ifNotNil: 
				[:ts | 
				self 
					doEmitTuple: aTuple
					formulaOperator: aFormulaOperator
					timeSeries: ts]]
		ifNotNil: 
			[:last | 
			aTuple timestamp &lt; last timestamp 
				ifTrue: [nil]
				ifFalse: 
					[((shouldDeduplicate or: [aTuple timestamp = last timestamp]) and: 
						[last value = aTuple value]) 
							ifTrue: [aFormulaOperator deduplicateTuple: aTuple]
							ifFalse: 
								[aFormulaOperator timeSeries ifNotNil: 
									[:ts | 
									self 
										doEmitTuple: aTuple
										formulaOperator: aFormulaOperator
										timeSeries: ts]]]]</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	^false</body>
</methods>


<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>smee interface</category>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate 
	&lt;prototypeFunctionNamed: #emitTuple length: 1 args: 'tuple' selector: #emitTuple:
	comment: 'Emits new tuple'&gt;
	
	^self window 
		emitTuple: aTuple
		shouldDeduplicate: shouldDeduplicate
		formulaOperator: self</body>

<body package="PV-ES-Formulas" selector="onAddTuple:">onAddTuple: aTuple

	self window onAddTuple: aTuple formulaOperator: self</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:">shouldDeduplicateOnAddTuple: aTuple

	^self window shouldDeduplicateOnAddTuple: aTuple formulaOperator: self</body>
</methods>


<methods>
<class-id>PROVISO.PvFormula</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="dependsOnFormula:">dependsOnFormula: aPvFormula 
 
	^self formulaPrototype 
		ifNil: [false]
		ifNotNil: 
			[:f | 
			self isSmee and: 
				[f arguments notNil and: 
					[f arguments anySatisfy: 
						[:eachArg | 
						eachArg pathFormulas notNil and: 
							[eachArg pathFormulas anySatisfy: 
								[:eachAssoc | 
								eachAssoc value notNil and: 
									[eachAssoc value == aPvFormula or: [eachAssoc value dependsOnFormula: aPvFormula]]]]]]]]</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>updating</category>

<body package="PV CML-Framework" selector="onAddTuple:">onAddTuple: aTuple
	"do nothing"</body>

<body package="PV CML-Framework" selector="shouldDeduplicateOnAddTuple:">shouldDeduplicateOnAddTuple: aTuple

	^false</body>
</methods>


<reorganize>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <organization>('calculation' #calculate)
('accessing' #arguments #disconnectFromHeartbeatSourcesIn: #element #expectedMetricCount #firstNeededTupleId #formula #indexOfArgumentForSequenceNumber:ifPresent:ifAbsent: #inputs #inputs: #metricCount #metricId #metricRecordClass #metricRecordManager #newSmalltalkInputForBinding: #numberOfInputs #operator #operatorTimeSeries #owner #owner: #request #request: #resource #resourceId #setOutputMetricRecordDate: #setOutputMetricRecordDateRounded: #subelement #timeSeries #timeSeriesInputsDo: #tupleRepository #validityWindow #validityWindow: #window)
('private' #buildResultMetricRecord #isAllPropertyInputFormula #isInputStateMachineReady #on: #privateUpdateInputAt:withProperty: #resetStaleInputsAt:with: #resourceId:)
('initialization' #initializeInstanceVariables #initializePropertyInputState #reset #resetInputState)
('invariant change' #checkInvariant: #checkInvariant:old:new: #checkInvariant:old:new:disable: #checkInvariantOld:new:)
('logging' #logBuildResultMetricRecordError: #logCalculationError:)
('user interface' #emphasisForTreeViewClosed #inspectorChildren #inspectorClasses #literalArrayEncoding #pvTextDisplayString #pvTreeViewLabelString)
('writing' #writeOn:)
('visiting' #acceptVisit:)
('printing' #printOn:)
('enumerating' #collect: #do:)
('icons' #icon)
('recomputations support' #getRecomputationScopeIn:for:at: #getRecomputationScopeIn:metricId:resourceId:at:)
('inputs' #inputForTimeSeries:atIndex:ifPresent:ifAbsent: #inputForTimeSeries:sequenceNumber:ifPresent:ifAbsent:)
('builder protocol' #deleteInputForTs:inputTs:sequenceNumber:withBuilder:)
('testing' #isBucket #isPeriodBased #isTupleBased)
('results' #ignoreResult #result:)
('updating' #onAddTuple: #runCalculationMethod #shouldDeduplicateOnAddTuple: #update:with: #update:with:with:from: #updateFromProperty: #updateInput: #updateInputAt:withDelta: #updateInputAt:withNumber: #updateInputAt:withProperty: #updateInputAt:withString: #updateInputsFor:)
</organization>
</reorganize>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>private</category>

<body package="PV-CME-Core" selector="injectBufferedTuplesIntoComputationsUntilAllDone">injectBufferedTuplesIntoComputationsUntilAllDone

	| formulasInBuffer inputFormulaIds tupleToTsList |	
	
	
	tupleToTsList := OrderedCollection new: heartbeatBuffer size.
	[heartbeatBuffer isEmpty]
		whileFalse:
			["build up a list of all formulas in the buffer"
			formulasInBuffer := Set new: 200.
			heartbeatBuffer do: [:array | formulasInBuffer add: array last formula].

			"find the formulaIds that do not depend on any other formulas in the buffer"
			inputFormulaIds := Set new: 200.
			formulasInBuffer do: 
				[:each | 
				(formulasInBuffer noneSatisfy: [:each2 | each dependsOnFormula: each2])
					ifTrue: [inputFormulaIds add: each id]].
		
			"build up a list of all timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList fastEmpty.
			heartbeatBuffer keysAndValuesDo: 
				[:midRidArray :tupleToTsArray | 
				(inputFormulaIds includes: midRidArray first)
					ifTrue: [tupleToTsList add: tupleToTsArray]].
	
			"remove the timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				heartbeatBuffer 
					removeMid: tupleToTsArray first metricId 
					rid: tupleToTsArray first resourceId 
					ifAbsent: []].
	
			"do onAddTuple: for each timeseries where the formula does not depend on any other formulas in the buffer.
			For tupleWindow type formulas this can result in more things being added to heartbeatBuffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				tupleToTsArray last onAddTuple: tupleToTsArray first]]</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>api</category>

<body package="PV-CME-Core" selector="addTupleNoUpdate:forTimeSeries:">addTupleNoUpdate: aMetricRecord forTimeSeries: anObject 
	" Push tuple into the storage "
	
	self buffer add: aMetricRecord</body>

<body package="PV-CME-Core" selector="handleHeartbeat:forAll:">handleHeartbeat: aHeartbeat forAll: sources 
	" Sort by evaluation order. aCollection is collection of heartbeat sources to fire now.
	Each heartbeat source has a list of subscribers, which are either heartbeat brokers,
	brokering heartbeat notifications for a specific formula (normal or intermediate heartbeats)
	or a time series. This method arranges these in the proper evaluation order. The order is as follows:
	1. All time series should evaluate before heartbeats
	2. Within time series formula that is a direct or indirect argument of another formula should be 
		evaluated before that formula
	3. Within heartbeats, heartbeats for a formula that is a direct or indirect argument of another formula 
		should be evaluated before heartbeats for that formula
	4. If both intermediate and normal heartbeats are to fire, only normal heartbeats should fire "
	
	| forEvaluation startHb |

	" Pass to close period for all sources due "
	" Heartbeats should be sent in the order that reflects nesting of the formulas,
	so we need to collect and sort everybody that is at the end of the period "
	forEvaluation := nil.
	sources do: [:eachSource |
		eachSource 
			clientsAtEndOfPeriodFor: aHeartbeat timestamp 
			do: [:eachBroker | 
				forEvaluation isNil ifTrue: [forEvaluation := ESFormulaSortedCollection new: 32].
				forEvaluation add: eachSource -&gt; eachBroker]].

	forEvaluation isNil 
		ifTrue: 
			[self injectBufferedTuplesIntoComputationsUntilAllDone.
			^self].
	" Now send each one end of period notification "
	forEvaluation do: [:eachAssoc | 
		eachAssoc key 	update: #addEndOfPeriod for: eachAssoc value with: aHeartbeat.

		"Now flush the metric records for real..."
		self injectBufferedTuplesIntoComputationsUntilAllDone].

	" Once period is fully closed, flush buffered tuples "
	"This is now handled by the minute policy..."
	"self flushBufferedTuplesUpTo: aHeartbeat timestamp."

	" Finally, send start of period notifications to all subscribers. 
	Start of period does not require a particular ordering since no tuples are generated at 
	start of period. Therefore it can be done at the heartbeat source level. 
	Each source will then propagate it to its clients "
	startHb := PvStreamHeartbeat timestamp: aHeartbeat timestamp + 1.
	forEvaluation do: [:eachAssoc | 
		eachAssoc key 
			update: #addStartOfPeriod
			for: eachAssoc value
			with: startHb].</body>
</methods>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>updating</category>

<body package="PV-CME-Core" selector="onAddTuple:">onAddTuple: aTuple 
	" New tuple is produced by the owner of this time series. 
	Store the tuple in the tupleRepository and distribute it to the local clients "

	"Ask the operator if this tuple should be deduplicated"	
	self operator ifNotNil: 
		[:aFormulaOperator | 
		(aFormulaOperator shouldDeduplicateOnAddTuple: aTuple) 
			ifTrue: [^aFormulaOperator deduplicateTuple: aTuple] 
			ifFalse: [aFormulaOperator onAddTuple: aTuple]].

	self tupleRepository 
		addTupleNoUpdate: aTuple
		forTimeSeries: self.
	self tupleRepository 
		changed: #onMetric
		with: aTuple.
	self onUpdateTuple: aTuple</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>private</category>

<body package="PV-CME-Core" selector="storeTuple:">storeTuple: aTuple 
	
	^self isProperty
		ifTrue: 
			[self subelement propertyValueAtFormula: self formula put: aTuple.
			nil]
		ifFalse:
			[self bufferedTuples isNil 
				ifTrue: [self bufferedTuples: (PvRawBucketSortedCollection sortBlock: [:a :b | a date &lt;= b date])].
			self bufferedTuples add: aTuple.
			self metricRecordsCount: self metricRecordsCount + 1.
			^self bufferedTuples size]</body>
</methods>


<methods>
<class-id>PROVISO.TupleWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		ts onBufferTuple: aTuple</body>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator timeSeries ifNotNil: 
		[:ts | 
		self 
			doEmitTuple: aTuple
			formulaOperator: aFormulaOperator
			timeSeries: ts]</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator

	aFormulaOperator lastTuple: aTuple</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	| last |

	"If we don't have a lastTuple then we should produce a value"
	(last := formulaOperator lastTuple) ifNil: [^false].

	"There should never be a new tuple for an earlier timestamp (moving back in time)"
	aTuple timestamp &lt; last timestamp
		ifTrue: [^true].

	"There should never be 2 tuples for the same timestamp"
	(aTuple timestamp = last timestamp and: [last value = aTuple value])
		ifTrue: [^true].

	"Real deduplication - where previous value is the same as this value"
	(formulaOperator shouldDeduplicate and: [last value = aTuple value])
		ifTrue: [^true].

	^false</body>
</methods>


<methods>
<class-id>PROVISO.CMEWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		aFormulaOperator lastTuple: aTuple.
		ts onAddTuple: aTuple.</body>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator lastTuple 
		ifNil: 
			[aFormulaOperator timeSeries ifNotNil: 
				[:ts | 
				self 
					doEmitTuple: aTuple
					formulaOperator: aFormulaOperator
					timeSeries: ts]]
		ifNotNil: 
			[:last | 
			aTuple timestamp &lt; last timestamp 
				ifTrue: [nil]
				ifFalse: 
					[((shouldDeduplicate or: [aTuple timestamp = last timestamp]) and: 
						[last value = aTuple value]) 
							ifTrue: [aFormulaOperator deduplicateTuple: aTuple]
							ifFalse: 
								[aFormulaOperator timeSeries ifNotNil: 
									[:ts | 
									self 
										doEmitTuple: aTuple
										formulaOperator: aFormulaOperator
										timeSeries: ts]]]]</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	^false</body>
</methods>



</st-source>
