<?xml version="1.0"?>

<st-source>
<!-- Changes in change set ra503316-queryPrefixes -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on June 23, 2008 at 7:59:54 am</time-stamp>


<methods>
<class-id>PROVISO.TimeSeries class</class-id> <category>database support</category>

<body package="PV-ES-Formulas" selector="bindVariableSelectStatementForCurrentLabelForMetricId:subelementId:">bindVariableSelectStatementForCurrentLabelForMetricId: metricId subelementId: subelementId
	"self bindVariableSelectStatementForCurrentLabelForMetricId: 1234 subelementId: 4567"

	| bindVariableArray |

	bindVariableArray := Array new: 2.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.

	^'SELECT distinct ts.int_label
		FROM ts_desc ts
		WHERE 
			ts.idx_metric = :1 
			and ts.idx_resource = :2 
			and ts.str_action = ''I'' 
			and ts.int_version_date = 
				(SELECT MAX(ts2.int_version_date)
					FROM ts_desc ts2
					WHERE 
						ts2.idx_metric = :1 
						AND ts2.idx_resource = :2)'
    				-&gt; bindVariableArray</body>

<body package="PV-ES-Formulas" selector="bindVariableSelectStatementForLabelForMetricId:subelementId:between:and:">bindVariableSelectStatementForLabelForMetricId: metricId 
	subelementId: subelementId
	between: beginTimestamp
	and: endTimestamp
	"self bindVariableSelectStatementForLabelForMetricId: 1234 subelementId: 4567 between: 5000 and: 1000"

	| bindVariableArray dateClause begin end subquery |
	begin := beginTimestamp ifNil: [Infinity negative].
	end := endTimestamp ifNil: [Infinity positive].
	(((begin == Infinity negative) or: [begin == Infinity positive]) and: [begin == end])
		ifTrue: [^nil].
	end &lt; begin ifTrue: [^nil].

	bindVariableArray := Array new: 4.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.
	bindVariableArray at: 3 put: begin.
	bindVariableArray at: 4 put: end.

	subquery := 
		'OR ts.int_version_date = 
			(SELECT MAX(ts2.int_version_date)
				FROM ts_desc ts2
				WHERE 
					ts2.idx_metric = :1 
					AND ts2.idx_resource = :2
					AND ts2.dte_date &lt; :3)'.
	((begin ~~ Infinity negative) and: [end ~~ Infinity positive]) 
		ifTrue:
			[dateClause := 'and (ts.dte_date between :3 and :4 ', subquery, ')']
		ifFalse:
			[((begin == Infinity negative) and: [end == Infinity positive])
				ifTrue:
					[dateClause := ''.
					bindVariableArray := bindVariableArray copyFrom: 1 to: 2]
				ifFalse:
					[(begin == Infinity negative) ifTrue: 
						[dateClause := 'and ts.dte_date &lt;= :3'.
						bindVariableArray at: 3 put: endTimestamp].
					(end == Infinity positive) ifTrue: 
						[dateClause := 'and (ts.dte_date &gt;= :3 ', subquery, ')'].
					bindVariableArray := bindVariableArray allButLast]].

	^('SELECT distinct ts.int_label
		FROM ts_desc ts
		WHERE 
			ts.idx_metric = :1 
			and ts.idx_resource = :2 
			and ts.str_action = ''I''', dateClause)
    				-&gt; bindVariableArray</body>
</methods>


<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - database</category>

<body package="PV-Tuple Storage Engine" selector="dbGetAdjustedSparseTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetAdjustedSparseTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession

	| adjClause |
	adjTime &gt; 0
		ifTrue: 
			[(adjTime == Infinity positive)
				ifTrue: [adjClause := '']
				ifFalse: [adjClause := 'and t2.dte_adj_date &lt;= :3']]
		ifFalse: 
			["This query is only interested in the sparse metrics...if adjTime &lt;= 0, nothing will be returned from the DB query anyway, so don't bother"
			^#() readStream].
	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: (adjClause isEmpty ifTrue: [3] ifFalse: [4]) do:
		[ :rangeClause :orderClause :vars | | sql |
		vars 
			at: 1 put: mid;
			at: 2 put: rid.
		adjClause isEmpty ifFalse: [vars at: 3 put: adjTime].
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value, idx_event
				from MTRC00_SNRW_000_FULL t1 
				where 
					idx_metric = :1 
					and idx_resource = :2 ',
					rangeClause,
					' and dte_adj_date &lt;&gt; 0
					and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date ', adjClause,') 
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvSparseMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					eventId: ((row at: 5) ifNil: [0]);
					yourself]].
	^#() readStream</body>

<body package="PV-Tuple Storage Engine" selector="dbGetSparseTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetSparseTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession

	| adjClause |
	adjClause := 'and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date'.
	adjTime &gt; 0
		ifTrue: 
			[(adjTime == Infinity positive)
				ifTrue: [adjClause := adjClause, ')']
				ifFalse: [adjClause := adjClause, ' and t2.dte_adj_date &lt;= :3)']]
		ifFalse: 
			[adjClause := 'and dte_adj_date = 0'].

	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: 4 do:
		[ :rangeClause :orderClause :vars | | sql |
		"We do the following because apparently Oracle applies the rownum clause before it sorts the results (ARG!)."
		vars 
			at: 1 put: mid;
			at: 2 put: rid;
			at: 3 put: adjTime.
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value, idx_event
				from MTRC00_SNRW_000_FULL t1 
				where 
					idx_metric = :1
					and idx_resource = :2
					', rangeClause, '
					 and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date)
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvSparseMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					eventId: (row at: 5);
					yourself]].
	^#() readStream</body>

<body package="PV-Tuple Storage Engine" selector="dbGetTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession
	"Note: adjTime is ignored because we don't currently support adjustments to periodic metrics"
	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: 3 do:
		[ :rangeClause :orderClause :vars | | sql |
		vars 
			at: 1 put: mid;
			at: 2 put: rid.
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value
				from MTRC00_NRAW_000_FULL t1 
				where 
					idx_metric = :1 
					and idx_resource = :2
					', rangeClause, '
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					yourself]].
	^#() readStream</body>
</methods>


<methods>
<class-id>PROVISO.PvChannelManagerDbInterface</class-id> <category>stored procedures</category>

<body package="PV-CMG" selector="registerCurrentChannelsFor:">registerCurrentChannelsFor: aConfiguration 
	
	self dbSession doProtected:
		[self dbSession withSessionNoTimeoutDo: 
			[:session | 
			session connection begin.
	[aConfiguration do:[ :anArray|
		session prepare: 
			'INSERT INTO GTT_CHNL_COMPONENT_DESC (IDX_CHNL, IDX_SUBCHNL) VALUES(?,?)'.
		session bindInput: anArray.
	session
		execute].
session preparePLSQL: 'BEGIN ' , 'PV_ADMIN.Pvm_Dataload.Update_Subchnl_Config_Status; END;'.
	session
		execute.
	session connection commit] ifCurtailed: [session connection rollback]]]</body>
</methods>


<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="bindVariableSelectStatementForLabelForMetricId:subelementId:between:and:">bindVariableSelectStatementForLabelForMetricId: metricId 
	subelementId: subelementId
	between: beginTimestamp
	and: endTimestamp
	"self bindVariableSelectStatementForLabelForMetricId: 1234 subelementId: 4567 between: 5000 and: 1000"

	| bindVariableArray |

	bindVariableArray := Array new: 4.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.
	bindVariableArray at: 3 put: beginTimestamp.
	bindVariableArray at: 4 put: endTimestamp.

	^ 'SELECT distinct ts1.int_label
         FROM ts_desc ts1
         WHERE ts1.idx_metric = :1 and ts1.idx_resource = :2 
           AND ts1.DTE_DATE = ( SELECT MAX(ts2.DTE_DATE)
                                FROM ts_desc ts2
                               WHERE ts1.idx_ind=ts2.idx_ind
                                 AND ts2.DTE_DATE between :3 and :4 )'
		-&gt; bindVariableArray</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>queries</category>

<body package="PV-DC-Recomputations" selector="isDuplicate:">isDuplicate: aRecompRecord

	| sql results |
	sql := 'select count(*) from MTRC00_SNRW_000_FULL where idx_metric = %1 and idx_resource = %2 and dte_date = %3 and dte_adj_date = %4 and idx_event = %5' bindWithArguments: { aRecompRecord metricId asString . aRecompRecord resourceId asString . aRecompRecord referenceDate asString . aRecompRecord date asString . aRecompRecord eventId asString }.
	results := self dbSession executeSelect: sql.
	^results isEmpty
		ifTrue: [false]
		ifFalse: [results first first &gt; 0]</body>
</methods>



</st-source>
