<?xml version="1.0"?>

<st-source>
<!-- Changes in change set ra503325-2CmesShouldNotHaveSameTsCalculate -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on June 27, 2008 at 2:24:49 pm</time-stamp>


<class>
<name>CmlSerializer</name>
<environment>PROVISO</environment>
<super>PROVISO.SimpleSerializer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>currentTupleSource operatorCount timeSeriesCount tupleCount tupleRepository skipTupleSourceFlagsOnRead </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>updating</category>

<body package="PV CML-Framework" selector="runCalculationMethod">runCalculationMethod
	
	[| result resultRecord |

	self timeSeries ifNotNil: [:ts | ts shouldFire ifFalse: [^self]].

	xxxPrivateFormulaResult := nil.
	[((result := self calculate) notNil and: [result ~~ self]) 
		ifTrue: 
			[result := 
				self class outputType == self class numberType 
					ifTrue: [result value asNumber]
					ifFalse: [result value asString].
			xxxPrivateFormulaResult := result]] 
				on: Error
				do: [:err | ^self logCalculationError: err].

	xxxPrivateFormulaResult isNil 
		ifFalse: 
			[[resultRecord := self buildResultMetricRecord] 
				on: Error
				do: [:err | ^self logBuildResultMetricRecordError: err].
			self owner isEnabled
				ifTrue: [self owner onAddTuple: resultRecord]]] 
				ensure: [self resetInputState]</body>
</methods>


<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>shouldFire flag</category>

<body package="PV-ES-Formulas" selector="shouldFire">shouldFire

	^true</body>

<body package="PV-ES-Formulas" selector="shouldFire:">shouldFire: aBool
	"Ignore"</body>
</methods>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="flagSpecs">flagSpecs

	^super flagSpecs, #(#(shouldFire shouldFireFlagMask))</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize

	super initialize.
	self
		shouldFire: true;
		periodsPerHour: 0;
		metricRecordsCount: 0;
		duplicateRecordCount: 0;
		droppedRecordCount: 0.</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>shouldFire flag</category>

<body package="PV-CME-Core" selector="clearShouldFireFlag">clearShouldFireFlag

	flags := flags maskClear: self shouldFireFlagMask</body>

<body package="PV-CME-Core" selector="setShouldFireFlag">setShouldFireFlag

	flags := flags maskSet: self shouldFireFlagMask</body>

<body package="PV-CME-Core" selector="shouldFire">shouldFire

	^(flags bitAnd: self shouldFireFlagMask) ~= 0</body>

<body package="PV-CME-Core" selector="shouldFire:">shouldFire: aBool

	aBool
		ifTrue: [self setShouldFireFlag]
		ifFalse: [self clearShouldFireFlag]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>flags</category>

<body package="PV-CME-Core" selector="shouldFireFlagMask">shouldFireFlagMask

	^2r00010000</body>
</methods>


<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>windowing api</category>

<body package="PV-ES-Formulas" selector="evaluate:withTuple:">evaluate: sel withTuple: aTuple 
	|temp|

	self timeSeries ifNotNil: [:ts | ts shouldFire ifFalse: [^nil]].

	^self environment do: 
		[[temp := self 
			invokeSmeeCallback: sel
			withArguments: (Array with: aTuple)
			ifAbsent: [nil]] 
				on: Error
				do: 
					[:err | 
					FormulaCalculationError 
						raiseRequestWith: self formula-&gt;sel 
						errorString: 'Calc error in ', sel, '(), formula ', self formula printString, ' mid: ', self metricId printString ,' rid: ', self resourceId printString, ', error: ', err description.
					(self inputs conform: [:eachInput | eachInput notNil])
						ifTrue: 
							[self 
								logWarnFailedCalculate: self formula printString
								selector: sel
								msg: err description  , ' for mid: ', self metricId printString ,' rid: ', self resourceId printString]
						ifFalse: 
							[| missingArgs |
							missingArgs := OrderedCollection new: self formula arguments size.
							self formula arguments keysAndValuesDo:  
								[:eachIx :eachArg | (self inputs at: eachIx) ifNil: [missingArgs add: eachArg]].
							self 
								logWarnFailedCalculate: self formula printString
								selector: sel
								msg: 'Formula is missing input(s) for arguments: ', missingArgs asArray printString , ' for mid: ', self metricId printString ,' rid: ', self resourceId printString].
					nil]]</body>
</methods>


<methods>
<class-id>PROVISO.PvInputAndTimeSeriesBuildCommand</class-id> <category>building</category>

<body package="PV-CME-Core" selector="addOrUpdatePlanDataWithBuilder:">addOrUpdatePlanDataWithBuilder: aTreeBuilder 
	
	| operatorTs inputTs |
	operatorTs := 
		self 
			buildTimeSeriesForMsid: self ownerTimeSeriesMsid
			metricId: self ownerMetricId
			resourceId: self ownerResourceId
			label: self ownerTimeSeriesLabel
			requestId: self ownerRequestId
			isExplicit: (aTreeBuilder isMyLabel: self ownerTimeSeriesLabel)
			withBuilder: aTreeBuilder.
	operatorTs shouldFire: (aTreeBuilder isMyLabel: self ownerTimeSeriesLabel).
	inputTs := 
		self 
			buildTimeSeriesForMsid: self inputTimeSeriesMsid
			metricId: self inputMetricId
			resourceId: self inputResourceId
			label: self inputTimeSeriesLabel
			requestId: self inputRequestId
			isExplicit: (aTreeBuilder isMyLabel: self inputTimeSeriesLabel)
			withBuilder: aTreeBuilder.
	inputTs shouldFire: (aTreeBuilder isMyLabel: self inputTimeSeriesLabel).
	operatorTs formula formulaPrototype ifNotNil: 
		[:formula | | contextResource |
		contextResource := self contextResourceId isNil
			ifTrue: [nil]
			ifFalse: [aTreeBuilder pvModel subelementManager getOrCreateNewInactiveItemWithId: self contextResourceId].
		formula 
			addOrUpdateInputForTs: operatorTs
			inputTs: inputTs
			sequenceNumber: self sequenceNumber
			versionDate: self versionDate
			currentResource: contextResource
			withBuilder: aTreeBuilder]</body>
</methods>


<methods>
<class-id>PROVISO.CmlSerializer</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize

	super initialize.
	timeSeriesCount := 0.
	operatorCount := 0.
	tupleCount := 0.
	skipTupleSourceFlagsOnRead := true.</body>
</methods>

<methods>
<class-id>PROVISO.CmlSerializer</class-id> <category>reading</category>

<body package="PV-CME-Core" selector="readTupleSource:">readTupleSource: aTupleSource

	timeSeriesCount := timeSeriesCount + 1.
	[currentTupleSource := aTupleSource.
	skipTupleSourceFlagsOnRead
		ifTrue: [self read]
		ifFalse: [	aTupleSource flags: self read].
	"We only write the owner if it is a formula operator, otherwise, we write a nil, so only set the owner if it's not nil"
	self read ifNotNil: [ :obj | aTupleSource owner: obj].
	^aTupleSource]
			ensure: [currentTupleSource := nil]</body>
</methods>



</st-source>
