<?xml version="1.0"?>

<st-source>
<!-- Changes in change set ra503337-dctvShowFormulaTs -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on July 1, 2008 at 3:46:19 pm</time-stamp>


<class>
<name>PvPblStateFileViewer</name>
<environment>PROVISO</environment>
<super>Tools.FileTools.FileContentsViewer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Tools-File Browser</category>
<attributes>
<package>PV-Development Enhancements</package>
</attributes>
</class>

<methods>
<class-id>Core.Boolean</class-id> <category>Smee</category>

<body package="Smee-Primitive Values" selector="smeeSumFromString:">smeeSumFromString: aString
	^self smeeToNumber smeeSumFromString: aString</body>
</methods>


<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>accessing trees</category>

<body package="PV-CME-Core" selector="rawBucketsKeysAndValuesDo:">rawBucketsKeysAndValuesDo: aBlock

	self rawData keysAndValuesDo: aBlock</body>
</methods>


<methods>
<class-id>PROVISO.PvPblStateFileViewer class</class-id> <category>accessing</category>

<body package="PV-Development Enhancements" selector="isInterestedInFile:">isInterestedInFile: aFilename 

	^#('versionBeingBuilt.state' 'versionLastBuilt.state' 'labelChangeHistory.state' 'aliasedCollectors.state' 'advanceCollectorRequests.state' 'operatorLabels.state' 'collectorLabels.state') includes: aFilename tail</body>

<body package="PV-Development Enhancements" selector="tabLabel">tabLabel

	^(self name &lt;&lt; #labels &gt;&gt; self name asString)</body>

<body package="PV-Development Enhancements" selector="tabPosition">tabPosition

	^2</body>
</methods>

<methods>
<class-id>PROVISO.PvPblStateFileViewer</class-id> <category>private</category>

<body package="PV-Development Enhancements" selector="largeFileThreshold">largeFileThreshold
	"Files larges than this number of bytes are displayed in preview mode first."

	^10000</body>

<body package="PV-Development Enhancements" selector="textForEntireFile:">textForEntireFile: aFilename 
	
	^(PROVISO.SimpleSerializer forReading: aFilename asFilename readStream binary) read printString</body>

<body package="PV-Development Enhancements" selector="textForFileBeginning:">textForFileBeginning: aFilename 

	^self textForEntireFile: aFilename</body>
</methods>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>user interface</category>

<body package="PV-CME-Core" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc coll1 |
	details := OrderedCollection new.
 	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self bufferedTuples ifNil: [#()].
	coll isEmpty
		ifTrue: 
			[self owner 
				ifNotNil: 
					[:operator | 
					operator lastTuple 
						ifNotNil: [:tuple | details add: (ObjectLabel key: 'Last record: ', tuple printString)]].
		]
		ifFalse: 
			[coll1 := OrderedCollection new: coll size.
			coll reverseDo: [:eachRec | 
				coll1 add: (ObjectLabel key: eachRec shortDigest value: eachRec)].
			details add: 
				((HierarchicalObjectWrapper 
					key: 'Records: '
					value: coll1)
					inspectorChildren: coll1;
					emphasis: #(veryDarkGray);
					icon: ListIconLibrary collection16x16;
					yourself)].
	" Add reference to the remote original time series if we are not local"
	self isLocalStreamLabel
		ifFalse: 
			[[liveTsAssoc := self getMyTimeSeries.
			details add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			(moreDetails
				add: (ObjectLabel key: 'Label: ' , obj printString value: obj);
				yourself) asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for (', self pvTreeViewLabelString, '...', ')' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			emphasis: #(veryDarkGray italic);
			yourself).
	^details asArray</body>
</methods>



</st-source>
