#!/bin/sh
#
# usage: uninstall.sh <datachannel home dir>
#
# List of ifixes
#
cd patch
PFILE_LIST=`ls`
cd ..


DC_HOME=$1
#
# Check if the DataChannel environments already sourced
#
[ -z "$DC_HOME" ] && echo "Datachannel environment not sourced properly" && exit 1

#
# Startup file to load the patch
#
SFILE=$DC_HOME/state/`$DC_HOME/bin/version|tail -1|sed 's/[   -][     ]*/ /g'|cut -d' ' -f3`.startup

for PFILE in ${PFILE_LIST}
do
   if [ -f "$DC_HOME/state/$PFILE" ]
   then
      echo "Uninstalling patch file $DC_HOME/state/$PFILE"
      rm -f $DC_HOME/state/$PFILE

      echo "Updating $SFILE"
      sed "/$PFILE' asFilename fileIn./d" < $SFILE > $SFILE.new
      rm $SFILE
      mv $SFILE.new $SFILE
   else
      #
      # Skip the uninstallation...
      #
      echo "Patch file $DC_HOME/state/$PFILE does not exist"
   fi
done
